static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0xD2, 0x41, 0x31, 0x37, 0xB9, 0x14, 0x9F, 0xAC, 0x37, 0x40,
        0xB0, 0x5D, 0x93, 0x69, 0xBE, 0x93, 0x80, 0x81, 0x4B, 0xC7,
        0x46, 0xBB, 0xF1, 0x86, 0x18, 0xA4, 0x4A, 0xF6, 0xC5, 0x04,
        0x0C, 0x9A, 0xB5, 0x3F, 0x93, 0x3A, 0x82, 0xB8, 0x45, 0x5F,
        0x2F, 0xD6, 0x9A, 0x5B, 0x69, 0xC2, 0xAE, 0xA0, 0x60, 0x0A,
        0x7D, 0x27, 0x1D, 0x09, 0x44, 0x03, 0x5C, 0xEB, 0xF9, 0xF8,
        0xD4, 0xD7, 0x2A, 0x23
    };
    static unsigned char dhg_512[] = {
        0x05
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
